package dev.shadowsoffire.apotheosis.ench.objects;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.ench.Ench;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.function.Function;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraftforge.common.loot.LootModifier;

public class WardenLootModifier extends LootModifier {
  public static final Codec<dev.shadowsoffire.apotheosis.ench.objects.WardenLootModifier> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, dev.shadowsoffire.apotheosis.ench.objects.WardenLootModifier::new));
  }
  
  public static final ResourceLocation WARDEN_TABLE_ID = new ResourceLocation("minecraft", "entities/warden");
  
  public WardenLootModifier(LootItemCondition[] conditionsIn) {
    super(conditionsIn);
  }
  
  public Codec<? extends IGlobalLootModifier> codec() {
    return (Codec)CODEC;
  }
  
  protected ObjectArrayList<ItemStack> doApply(ObjectArrayList<ItemStack> loot, LootContext ctx) {
    if (Apotheosis.enableEnch && WARDEN_TABLE_ID.equals(ctx.getQueriedLootTableId())) {
      int amount = 1;
      if (ctx.m_230907_().m_188501_() <= 0.1F + ctx.getLootingModifier() * 0.1F)
        amount++; 
      loot.add(new ItemStack((ItemLike)Ench.Items.WARDEN_TENDRIL.get(), amount));
    } 
    return loot;
  }
}
